Index: TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/utils/JobHandler.java
===================================================================
--- TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/utils/JobHandler.java	(revision 3627)
+++ TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/utils/JobHandler.java	(revision 3628)
@@ -37,6 +37,7 @@
 import org.eclipse.swt.widgets.Display;
 import org.eclipse.ui.internal.progress.ProgressManagerUtil;
 import org.eclipse.ui.texteditor.ISchedulingRuleProvider;
+import org.txm.rcp.Application;
 import org.txm.rcp.StatusLine;
 import org.txm.rcp.messages.TXMUIMessages;
 import org.txm.utils.logger.Log;
@@ -202,7 +203,11 @@
 	 *            the runable
 	 */
 	public void syncExec(Runnable runable) {
-		Display.getDefault().syncExec(runable);
+		if (Display.getDefault() != null && !Application.isHeadLess()) {
+			Display.getDefault().syncExec(runable);
+		} else {
+			runable.run();
+		}
 	}
 	
 	public void startJob() {
@@ -216,7 +221,7 @@
 		// if (modal) { // this will deadlock the job if the jobs needs to work on the RCP workspace files
 		// this.setRule(org.eclipse.core.resources.ResourcesPlugin.getWorkspace().getRoot());// set modal job
 		// }
-		this.setUser(true);// show popup
+		this.setUser(modal);// show popup
 		this.schedule();// start
 	}
 	
Index: TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/utils/SWTEditorsUtils.java
===================================================================
--- TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/utils/SWTEditorsUtils.java	(revision 3627)
+++ TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/utils/SWTEditorsUtils.java	(revision 3628)
@@ -70,7 +70,7 @@
 						for (int i = 0; i < txmMultipageEditor.getEditors().size(); i++) {
 							if (txmMultipageEditor.getEditors().get(i) instanceof ITXMResultEditor) {
 								ITXMResultEditor txmEditor = ((ITXMResultEditor) txmMultipageEditor.getEditors().get(i));
-								ArrayList eds = tmpEditors.get(txmEditor.getResult());
+								ArrayList<ITXMResultEditor<TXMResult>> eds = tmpEditors.get(txmEditor.getResult());
 								if (eds == null) {
 									eds = new ArrayList<>();
 									tmpEditors.put(txmEditor.getResult(), eds);
Index: TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/preferences/RCPPreferences.java
===================================================================
--- TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/preferences/RCPPreferences.java	(revision 3627)
+++ TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/preferences/RCPPreferences.java	(revision 3628)
@@ -102,7 +102,7 @@
 		preferences.putBoolean(CGU, false);
 		
 		preferences.putInt(NO_SESSION, 1);
-		preferences.putInt(MAX_NUMBER_OF_COLUMNS, 50);
+		preferences.putInt(MAX_NUMBER_OF_COLUMNS, 100);
 	}
 	
 	/**
Index: TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/commands/RecoverCorporaFromInstalls.java
===================================================================
--- TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/commands/RecoverCorporaFromInstalls.java	(revision 0)
+++ TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/commands/RecoverCorporaFromInstalls.java	(revision 3628)
@@ -0,0 +1,240 @@
+package org.txm.rcp.commands;
+
+import java.io.File;
+import java.io.IOException;
+import java.util.ArrayList;
+import java.util.Arrays;
+import java.util.HashMap;
+import java.util.List;
+
+import org.eclipse.core.commands.AbstractHandler;
+import org.eclipse.core.commands.ExecutionEvent;
+import org.eclipse.core.commands.ExecutionException;
+import org.eclipse.core.runtime.IProgressMonitor;
+import org.eclipse.core.runtime.IStatus;
+import org.eclipse.core.runtime.Platform;
+import org.eclipse.jface.viewers.ArrayContentProvider;
+import org.eclipse.jface.viewers.LabelProvider;
+import org.eclipse.osgi.util.NLS;
+import org.eclipse.swt.widgets.DirectoryDialog;
+import org.eclipse.swt.widgets.Display;
+import org.eclipse.swt.widgets.Shell;
+import org.eclipse.ui.dialogs.ListSelectionDialog;
+import org.osgi.framework.Version;
+import org.txm.Toolbox;
+import org.txm.rcp.Activator;
+import org.txm.rcp.commands.workspace.LoadBinaryCorporaDirectory;
+import org.txm.rcp.messages.TXMUIMessages;
+import org.txm.rcp.utils.JobHandler;
+import org.txm.utils.DeleteDir;
+import org.txm.utils.io.IOUtils;
+import org.txm.utils.logger.Log;
+
+public class RecoverCorporaFromInstalls extends AbstractHandler {
+
+	/*
+	 * (non-Javadoc)
+	 * @see org.eclipse.core.commands.AbstractHandler#execute(org.eclipse.core.commands.ExecutionEvent)
+	 */
+	@Override
+	public Object execute(ExecutionEvent event) throws ExecutionException {
+
+		JobHandler job = new JobHandler("Recovering corpora") {
+
+			@Override
+			protected IStatus run(IProgressMonitor monitor) {
+				try {
+					restore(false);
+				} catch (Exception e) {
+					e.printStackTrace();
+					return org.eclipse.core.runtime.Status.CANCEL_STATUS;
+				}
+
+				return org.eclipse.core.runtime.Status.OK_STATUS;
+			}
+		};
+
+		job.schedule();
+		return job;
+	}
+
+	public static void restore(boolean currentTXM) throws IllegalStateException, IOException {
+
+		String installdirpath = Toolbox.getInstallDirectory();
+		File sampleCorporaDirectory = new File(installdirpath, "samples"); //$NON-NLS-1$
+
+		File txmhomedir = Platform.getLocation().toFile().getCanonicalFile();
+		txmhomedir.mkdirs(); // creates the directory if needed
+
+		File corporaDir = new File(txmhomedir, "corpora"); //$NON-NLS-1$
+
+		String previousVersions[] = { "0.8.2", "0.8.1", "0.8.0", "0.7.9" }; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
+		String previousVersionLabels[] = new String[previousVersions.length];
+		File previousVersionCorporaDirectories[] = new File[previousVersions.length];
+
+		for (int i = 0; i < previousVersions.length; i++) {
+			String v = previousVersions[i];
+
+			previousVersionLabels[i] = TXMUIMessages.bind(TXMUIMessages.corporaOfPreviousTXMP0, v);
+
+			File dir = new File(System.getProperty("user.home"), "TXM-" + v + "/corpora"); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
+			if ("0.7.9".equals(v)) { //$NON-NLS-1$
+				dir = new File(System.getProperty("user.home"), "TXM/corpora"); //$NON-NLS-1$ //$NON-NLS-2$
+			}
+			previousVersionCorporaDirectories[i] = dir;
+		}
+
+		Version v = Activator.getDefault().getBundle().getVersion();
+		String vv = v.getMajor() + "." + v.getMinor() + "." + v.getMicro(); //$NON-NLS-1$ //$NON-NLS-2$ $NON-NLS-2$
+		String SAMPLES = "1. " + TXMUIMessages.bind(TXMUIMessages.sampleCorporaOfCurrentTXMP0, vv); //$NON-NLS-1$
+		int n = 2;
+		String vCURRENT = "2. " + TXMUIMessages.bind(TXMUIMessages.corporaOfPreviousTXMP0, vv); //$NON-NLS-1$
+
+
+		final ArrayList<Object> selectedCorporaDirs = new ArrayList<>();
+		final ArrayList<Object> initialSelectionCorporaDirs = new ArrayList<>();
+
+		selectedCorporaDirs.add(SAMPLES);
+		initialSelectionCorporaDirs.add(SAMPLES);
+
+		if (currentTXM && corporaDir.exists() && corporaDir.listFiles(IOUtils.HIDDENFILE_FILTER).length > 0) {
+			selectedCorporaDirs.add(vCURRENT);
+			initialSelectionCorporaDirs.add(vCURRENT);
+			n++;
+		}
+
+		for (int i = 0; i < previousVersions.length; i++) {
+			if (previousVersionCorporaDirectories[i].exists()
+					&& previousVersionCorporaDirectories[i].listFiles(IOUtils.HIDDENFILE_FILTER).length > 0) {
+				previousVersionLabels[i] = "" + (n++) + ". " + previousVersionLabels[i];
+				selectedCorporaDirs.add(previousVersionLabels[i]); //$NON-NLS-1$ //$NON-NLS-2$
+			}
+		}
+
+		String OTHER = "" + (n++) + ". " + TXMUIMessages.selectAnotherTXMCorporaToRestore; //$NON-NLS-1$ //$NON-NLS-2$
+		selectedCorporaDirs.add(OTHER);
+
+		Display.getDefault().syncExec(new Runnable() {
+
+			@Override
+			public void run() {
+				Display display = Display.getDefault();
+				Shell shell = display.getActiveShell();
+
+				ListSelectionDialog dialog = ListSelectionDialog.of(selectedCorporaDirs)
+						.contentProvider(new ArrayContentProvider())
+						.labelProvider(new LabelProvider())
+						.message(TXMUIMessages.corporaWillBeRestoredInTheFollowingOrderCorporaAlreadyRestoredWillNotBeReplaced)
+						.title(TXMUIMessages.selectThecorporaSetsToRestore)
+						.create(shell);
+
+				dialog.setTitle(TXMUIMessages.selectThecorporaSetsToRestore);
+				dialog.setInitialElementSelections(initialSelectionCorporaDirs);
+				if (dialog.open() == ListSelectionDialog.OK) {
+					selectedCorporaDirs.clear();
+					List<Object> selection = Arrays.asList(dialog.getResult());
+					selectedCorporaDirs.addAll(selection);
+				}
+				else {
+					selectedCorporaDirs.clear();
+				}
+			}
+		});
+
+		// move the previous TXM 0.8.3 corpora
+		File backupDir = new File(corporaDir.getAbsolutePath() + "-previous"); //$NON-NLS-1$
+		if (currentTXM) {
+			if (corporaDir.exists()) {
+				backupDir.mkdirs();
+				for (File dir : corporaDir.listFiles(IOUtils.HIDDENFILE_FILTER)) {
+					File bdir = new File(backupDir, dir.getName());
+					DeleteDir.deleteDirectory(bdir);
+					dir.renameTo(bdir);
+				}
+			}
+
+			corporaDir.mkdir();
+		}
+
+		// load TXM-0.8.3 sample corpora (from the install directory)
+		if (selectedCorporaDirs.contains(SAMPLES) && sampleCorporaDirectory.exists()) {
+
+			Log.info(TXMUIMessages.installingSampleCorpus);
+
+			JobHandler job = LoadBinaryCorporaDirectory.loadBinaryCorpusFromCorporaDirectory(sampleCorporaDirectory, false, true, false);
+			try {
+				job.join();
+			}
+			catch (InterruptedException e) {
+				// TODO Auto-generated catch block
+				e.printStackTrace();
+			}
+		}
+
+		// TXM-CURRENT previous installation corpora
+		if (currentTXM && selectedCorporaDirs.contains(vCURRENT) && backupDir.listFiles(IOUtils.HIDDENFILE_FILTER).length > 0) { // not a new install, restore corpus from the corpora-previous directory
+			Log.info(NLS.bind(TXMUIMessages.installingPreviousCorpusFromP0, vv, corporaDir));
+			JobHandler job = LoadBinaryCorporaDirectory.loadBinaryCorpusFromCorporaDirectory(backupDir, false, false, true);
+			try {
+				job.join();
+			}
+			catch (InterruptedException e) {
+				e.printStackTrace();
+			}
+		}
+
+		for (int i = 0; i < previousVersions.length; i++) {
+			if (selectedCorporaDirs.contains(previousVersionLabels[i])) {
+
+				Log.info(NLS.bind(TXMUIMessages.installingPreviousCorpusFromP0, previousVersions[i], previousVersionCorporaDirectories[i]));
+
+				JobHandler job = LoadBinaryCorporaDirectory.loadBinaryCorpusFromCorporaDirectory(previousVersionCorporaDirectories[i], false, false, true);
+				try {
+					job.join();
+				}
+				catch (InterruptedException e) {
+					e.printStackTrace();
+				}
+			}
+		}
+
+		// recovery from an other corpora directory to select by the user
+		if (selectedCorporaDirs.contains(OTHER)) { // new installation (empty corpora directory)
+			final HashMap<String, String> bindings = new HashMap<>();
+			Display.getDefault().syncExec(new Runnable() {
+
+				@Override
+				public void run() {
+					Display display = Display.getDefault();
+					Shell shell = display.getActiveShell();
+					DirectoryDialog dialog = new DirectoryDialog(shell);
+					String path = dialog.open();
+					if (path == null) return;
+
+					bindings.put("path", path); //$NON-NLS-1$
+				}
+			});
+			if (bindings.containsKey("path")) { //$NON-NLS-1$
+				File dir = new File(bindings.get("path")); //$NON-NLS-1$
+				if (!dir.equals(corporaDir)) {
+					Log.info(NLS.bind(TXMUIMessages.restoringCorporaFromTheP0Directory, dir));
+					JobHandler job = LoadBinaryCorporaDirectory.loadBinaryCorpusFromCorporaDirectory(dir, true, true, true);
+					try {
+						job.join();
+					}
+					catch (InterruptedException e) {
+						e.printStackTrace();
+					}
+				}
+			}
+		}
+
+		Display.getDefault().syncExec(new Runnable() {
+
+			@Override
+			public void run() {
+				RestartTXM.reloadViews();
+			}
+		});	
+	}
+}

Index: TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/commands/ChangeTXMWorkspace.java
===================================================================
--- TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/commands/ChangeTXMWorkspace.java	(revision 3627)
+++ TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/commands/ChangeTXMWorkspace.java	(revision 3628)
@@ -94,7 +94,7 @@
 				return Status.OK_STATUS;
 			}
 		};
-		jobhandler.startJob();
+		jobhandler.startJob(false);
 		return event;
 	}
 
@@ -103,7 +103,7 @@
 			defaultValue = ResourcesPlugin.getWorkspace().getRoot().getLocation().toFile().getAbsolutePath();
 		}
 		ChooseWorkspaceData launchData = new ChooseWorkspaceData(defaultValue);
-		DirectoryDialog dialog = new DirectoryDialog(Display.getCurrent().getActiveShell());
+		DirectoryDialog dialog = new DirectoryDialog(Display.getDefault().getActiveShell());
 		dialog.setText(TXMUIMessages.selectWorkingDirectory);
 		dialog.setMessage(TXMUIMessages.ThisWillRestartTXM);
 		dialog.setFilterPath(defaultValue);
Index: TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/commands/ImportClipboardText.java
===================================================================
--- TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/commands/ImportClipboardText.java	(revision 3627)
+++ TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/commands/ImportClipboardText.java	(revision 3628)
@@ -33,6 +33,7 @@
 import java.io.OutputStreamWriter;
 import java.io.Writer;
 import java.util.Arrays;
+import java.util.List;
 import java.util.Locale;
 
 import org.eclipse.core.commands.AbstractHandler;
@@ -40,6 +41,8 @@
 import org.eclipse.core.commands.ExecutionException;
 import org.eclipse.jface.dialogs.MessageDialog;
 import org.eclipse.osgi.util.NLS;
+import org.eclipse.swt.SWT;
+import org.eclipse.swt.widgets.Display;
 import org.eclipse.swt.widgets.Shell;
 import org.eclipse.ui.handlers.HandlerUtil;
 import org.txm.Toolbox;
@@ -49,11 +52,13 @@
 import org.txm.objects.Workspace;
 import org.txm.rcp.handlers.scripts.ExecuteImportScript;
 import org.txm.rcp.messages.TXMUIMessages;
+import org.txm.rcp.swt.dialog.ComboDialog;
 import org.txm.rcp.swt.dialog.TextDialog;
 import org.txm.searchengine.cqp.ReferencePattern;
 import org.txm.searchengine.cqp.corpus.CorpusManager;
 import org.txm.treetagger.core.preferences.TreeTaggerPreferences;
 import org.txm.utils.LangDetector;
+import org.txm.utils.logger.Log;
 
 /**
  * Import the text in the Clipboard as a corpus. The loader used is the QuickLoader.
@@ -74,17 +79,25 @@
 	@Override
 	public Object execute(ExecutionEvent event) throws ExecutionException {
 		String result = org.txm.rcp.utils.IOClipboard.read();
+		
 		if (result == null || result.length() == 0) {
-			System.out.println(TXMUIMessages.NoCopiedTextAborting);
+			MessageDialog.openError(Display.getDefault().getActiveShell(), TXMUIMessages.error, TXMUIMessages.clipboardIsEmpty);
 			return null;
 		}
-		System.out.println(TXMUIMessages.importClipboardText);
+		
+		result = result.trim();
+		if (result.length() == 0) {
+			MessageDialog.openError(HandlerUtil.getActiveShell(event), TXMUIMessages.error, TXMUIMessages.clipboardIsEmpty);
+			return null;
+		}
+		
+		Log.info(TXMUIMessages.importClipboardText);
 
 		try {
 			String corpusName = TXMUIMessages.clipboard_2.toUpperCase()+(nextclipcorpus++);
 			File wl = Toolbox.workspace.getLocation();
 			if (wl == null) {
-				System.err.println("Error: Toolbox is not correctly initialized. Clipboard import aborted."); //$NON-NLS-1$
+				Log.warning("Error: Toolbox is not correctly initialized. Clipboard import aborted."); //$NON-NLS-1$
 				return null;
 			}
 			while (new File(wl, corpusName).exists()) {
@@ -93,10 +106,12 @@
 			
 			String lang = TBXPreferences.getInstance().getString(TBXPreferences.CLIPBOARD_IMPORT_DEFAULT_LANG);
 			boolean askLang = TBXPreferences.getInstance().getBoolean(TBXPreferences.CLIPBOARD_IMPORT_ASK_LANG);
-			TextDialog dialog = new TextDialog(HandlerUtil.getActiveShell(event), TXMUIMessages.SelectTheImportLanguageToUse, TXMUIMessages.WhatLanguageMustBeUsedToImportTheClipboardContent, lang);
+			List<String> langs = Arrays.asList("fr", "en");
+			//ComboDialog dialog = new ComboDialog(HandlerUtil.getActiveShell(event), TXMUIMessages.SelectTheImportLanguageToUse, TXMUIMessages.WhatLanguageMustBeUsedToImportTheClipboardContent, lang);
+			ComboDialog dialog = new ComboDialog(HandlerUtil.getActiveShell(event), TXMUIMessages.textLanguage, langs, lang, SWT.SINGLE);
 			if (askLang) {
 				if (dialog.open() == TextDialog.CANCEL) return null;
-				lang = dialog.getText();
+				lang = dialog.getSelectedValue();
 			}
 			importText(result, corpusName, lang);
 			
@@ -117,8 +132,9 @@
 	 */
 	public static Object importText(String text, String corpusname, String lang) throws Exception {
 		corpusname = corpusname.toUpperCase();
+		text = text.trim();
 		if (text.length() == 0) {
-			System.err.println(TXMUIMessages.clipboardIsEmpty);
+			Log.warning(TXMUIMessages.clipboardIsEmpty);
 			return null;
 		}
 		String txmhome = Toolbox.getTxmHomePath();
@@ -164,10 +180,10 @@
 		if ("??".equals(lang)) { //$NON-NLS-1$
 			LangDetector detector = new LangDetector(quicksrc);
 			lang = detector.getLang();
-			System.out.println(TXMCoreMessages.bind(TXMUIMessages.identifiedLanguage, lang));
+			Log.info(TXMCoreMessages.bind(TXMUIMessages.identifiedLanguage, lang));
 		}
 		project.setLang(lang); //$NON-NLS-1$
-		System.out.println(TXMCoreMessages.bind(TXMUIMessages.usingLanguage, project.getLang()));
+		Log.info(TXMCoreMessages.bind(TXMUIMessages.usingLanguage, project.getLang()));
 		
 		String ttpath = TreeTaggerPreferences.getInstance().getString(TreeTaggerPreferences.INSTALL_PATH);
 		
Index: TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/commands/editor/PrintHexacode.java
===================================================================
--- TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/commands/editor/PrintHexacode.java	(revision 3627)
+++ TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/commands/editor/PrintHexacode.java	(revision 3628)
@@ -29,8 +29,6 @@
 
 import java.math.BigInteger;
 
-import javax.xml.bind.DatatypeConverter;
-
 import org.eclipse.core.commands.AbstractHandler;
 import org.eclipse.core.commands.ExecutionEvent;
 import org.eclipse.core.commands.ExecutionException;
Index: TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/commands/RestartTXM.java
===================================================================
--- TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/commands/RestartTXM.java	(revision 3627)
+++ TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/commands/RestartTXM.java	(revision 3628)
@@ -35,6 +35,7 @@
 import org.eclipse.core.runtime.Status;
 import org.eclipse.core.runtime.jobs.Job;
 import org.eclipse.osgi.util.NLS;
+import org.eclipse.ui.PlatformUI;
 import org.txm.Toolbox;
 import org.txm.rcp.JobsTimer;
 import org.txm.rcp.messages.TXMUIMessages;
@@ -108,6 +109,9 @@
 	}
 	
 	public static void reloadViews() {
+		
+		if (!PlatformUI.isWorkbenchRunning()) return;
+		
 		// System.out.println(Messages.RestartTXM_0);
 		// TODO TXM views must have been registered to be reloaded
 		
Index: TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/commands/workspace/LoadBinaryCorporaDirectory.java
===================================================================
--- TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/commands/workspace/LoadBinaryCorporaDirectory.java	(revision 3627)
+++ TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/commands/workspace/LoadBinaryCorporaDirectory.java	(revision 3628)
@@ -54,6 +54,7 @@
 import org.txm.core.engines.EngineType;
 import org.txm.core.messages.TXMCoreMessages;
 import org.txm.objects.Project;
+import org.txm.objects.Workspace;
 import org.txm.rcp.IImageKeys;
 import org.txm.rcp.StatusLine;
 import org.txm.rcp.commands.RestartTXM;
@@ -158,7 +159,7 @@
 							@Override
 							public void run() {
 								
-								ArrayList<Project> tmp = loadBinaryCorpusFromCorporaDirectory(files, self, monitor, replace);
+								ArrayList<Project> tmp = loadBinaryCorpusFromCorporaDirectory(files, self, monitor, replace, directory.getAbsolutePath());
 								if (tmp != null) {
 									newProjects.addAll(tmp);
 								}
@@ -168,7 +169,7 @@
 					}
 					else { // try loading corpora and dont replace existing corpus
 						List<File> files = Arrays.asList(getBinaryCorpusFiles(directory, loadDirectories));
-						ArrayList<Project> tmp = loadBinaryCorpusFromCorporaDirectory(files, this, monitor, replace);
+						ArrayList<Project> tmp = loadBinaryCorpusFromCorporaDirectory(files, this, monitor, replace, directory.getAbsolutePath());
 						if (tmp != null) {
 							newProjects.addAll(tmp);
 						}
@@ -336,7 +337,7 @@
 	 */
 	protected static ArrayList<Project> loadBinaryCorpusFromCorporaDirectory(File directory, JobHandler job, IProgressMonitor monitor, boolean replace) {
 		File[] files = directory.listFiles(IOUtils.HIDDENFILE_FILTER);
-		return loadBinaryCorpusFromCorporaDirectory(Arrays.asList(files), job, monitor, replace);
+		return loadBinaryCorpusFromCorporaDirectory(Arrays.asList(files), job, monitor, replace, directory.getAbsolutePath());
 	}
 
 	/**
@@ -349,7 +350,7 @@
 	 * @param loadDirectories
 	 * @return the loaded projects
 	 */
-	protected static ArrayList<Project> loadBinaryCorpusFromCorporaDirectory(List<File> corporaFiles, JobHandler job, IProgressMonitor monitor, boolean replace) {
+	protected static ArrayList<Project> loadBinaryCorpusFromCorporaDirectory(List<File> corporaFiles, JobHandler job, IProgressMonitor monitor, boolean replace, String sourceName) {
 
 		ArrayList<Project> projects = new ArrayList<>();
 
@@ -360,13 +361,20 @@
 			// engine.stop();
 			// }
 
-			monitor.beginTask(TXMUIMessages.loadingBinaryCorpus, 100);
+			if (sourceName.matches(".+/TXM-.\\..\\../corpora")) {
+				sourceName = "TXM"+sourceName.substring(sourceName.length()-14, sourceName.length()-8);
+			}
+			monitor.beginTask(TXMUIMessages.loadingBinaryCorpus +" "+sourceName+" ("+corporaFiles.size()+").", corporaFiles.size());
 			// job.acquireSemaphore();
 			// Toolbox.getEngineManager(EngineType.SEARCH).stopEngines();
 			// job.releaseSemaphore();
 
-			monitor.subTask(TXMUIMessages.loadingTheCorpusInThePlatform);
+			
+			int n = 0;
 			for (File corpusDirectory : corporaFiles) {
+				n++;
+				monitor.subTask(TXMUIMessages.loadingTheCorpusInThePlatform+": \n"+corpusDirectory.getName()+" ("+n+"/"+corporaFiles.size()+").");
+				monitor.worked(1);
 				try {
 					if (corpusDirectory.isHidden()) {
 						continue;
@@ -380,7 +388,11 @@
 					}
 
 					if (corpusDirectory.isDirectory()) {
-						project = LoadBinaryCorpus.loadBinaryCorpusAsDirectory(corpusDirectory, monitor, replace);
+						if (Workspace.isCorpusBinarydirectoryValid(corpusDirectory)) {
+							project = LoadBinaryCorpus.loadBinaryCorpusAsDirectory(corpusDirectory, monitor, replace);
+						} else {
+							Log.fine("Skip recovering of corpus: "+corpusDirectory);
+						}
 					}
 					else {
 						project = LoadBinaryCorpus.loadBinaryCorpusArchive(corpusDirectory, job, monitor, replace);
Index: TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/commands/workspace/LoadBinaryCorpus.java
===================================================================
--- TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/commands/workspace/LoadBinaryCorpus.java	(revision 3627)
+++ TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/commands/workspace/LoadBinaryCorpus.java	(revision 3628)
@@ -306,7 +306,6 @@
 	public static Project loadBinaryCorpusAsDirectory(File corpusDirectory, IProgressMonitor monitor, boolean replace) throws Exception {
 		if (!(corpusDirectory.exists() && corpusDirectory.isDirectory())) {
 			Log.warning(NLS.bind(TXMUIMessages.failedToLoadCorpusP0, corpusDirectory.getAbsolutePath()));
-			System.out.println(NLS.bind(TXMUIMessages.failedToLoadCorpusP0, corpusDirectory.getAbsolutePath()));
 			return null;
 		}
 		
Index: TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/ApplicationWorkbenchWindowAdvisor.java
===================================================================
--- TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/ApplicationWorkbenchWindowAdvisor.java	(revision 3627)
+++ TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/ApplicationWorkbenchWindowAdvisor.java	(revision 3628)
@@ -87,7 +87,7 @@
 		configurer.setShowMenuBar(true);
 		configurer.setShowCoolBar(true);
 		configurer.setShowStatusLine(true);
-		configurer.setShowFastViewBars(false);
+		//configurer.setShowFastViewBars(false);
 		configurer.setShowProgressIndicator(true);
 		configurer.setShowPerspectiveBar(true);
 		configurer.setTitle(TXMUIMessages.tXM);
Index: TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/IImageKeys.java
===================================================================
--- TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/IImageKeys.java	(revision 3627)
+++ TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/IImageKeys.java	(revision 3628)
@@ -306,7 +306,7 @@
 	 * @param imageFilePath
 	 * @return
 	 */
-	public static ImageDescriptor getImageDescriptor(Class classOfPlugin, String imageFilePath) {
+	public static ImageDescriptor getImageDescriptor(Class<?> classOfPlugin, String imageFilePath) {
 		return getImageDescriptor(FrameworkUtil.getBundle(classOfPlugin).getSymbolicName(), imageFilePath);
 	}
 	
Index: TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/editors/imports/sections/LangSection.java
===================================================================
--- TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/editors/imports/sections/LangSection.java	(revision 3627)
+++ TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/editors/imports/sections/LangSection.java	(revision 3628)
@@ -72,7 +72,7 @@
 		sectionClient.setLayout(slayout);
 		this.section.setClient(sectionClient);
 		
-		Label l = toolkit.createLabel(sectionClient, "Language/Langue"); //$NON-NLS-1$
+		Label l = toolkit.createLabel(sectionClient, TXMUIMessages.textLanguage); //$NON-NLS-1$
 		TableWrapData gdata = getTextGridData();
 		gdata.colspan = 2;
 		l.setLayoutData(gdata);
@@ -103,33 +103,13 @@
 			public void widgetSelected(SelectionEvent e) {
 				btnSelectLang.setSelection(true);
 				btnGuessLang.setSelection(false);
-				// btnDefaultLang.setSelection(false);
 			}
 		});
 		
-		String locale = Locale.getDefault().getLanguage().toLowerCase();
-		int langToSelectIndex = -1;
-		int added = 0;
-		String modelsDir = TreeTaggerPreferences.getInstance().getString(TreeTaggerPreferences.MODELS_PATH);
-		File files[] = new File(modelsDir).listFiles(IOUtils.HIDDENFILE_FILTER);
-		if (files != null && files.length > 0) {
-			for (File model : files) {
-				if (!model.getName().endsWith(".par")) continue; //$NON-NLS-1$
-				String lang = FileUtils.stripExtension(model);
-				langcombo.add(lang);
-				if (locale.equals(lang)) {
-					langToSelectIndex = added;
-				}
-				added++;
-			}
-		}
-		if (added == 0) {
-			String[] langs = { "bg", "cat", "zh", "cop", "cs", "dk", "nl", "en", "ee", "fi ", "fr", "gl", "gr", "de", "ne", "it", "kr", "lat", "mn", "pl", "pt", "ro", "ru", "sk", "sl", "es", "tz" }; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$ //$NON-NLS-6$ //$NON-NLS-7$ //$NON-NLS-8$ //$NON-NLS-9$ //$NON-NLS-10$ //$NON-NLS-11$ //$NON-NLS-12$ //$NON-NLS-13$ //$NON-NLS-14$ //$NON-NLS-15$ //$NON-NLS-16$ //$NON-NLS-17$ //$NON-NLS-18$ //$NON-NLS-19$ //$NON-NLS-20$ //$NON-NLS-21$ //$NON-NLS-22$ //$NON-NLS-23$ //$NON-NLS-24$ //$NON-NLS-25$ //$NON-NLS-26$ //$NON-NLS-27$
-			Arrays.sort(langs);
-			langToSelectIndex = Arrays.binarySearch(langs, locale);
-			langcombo.setItems(langs);
-		}
-		
+		String locale = Locale.getDefault().getLanguage().toLowerCase(); // default lang
+		String[] langs = getAvailableLangs(); // get available langs from treetagger models if any
+		int langToSelectIndex = Arrays.binarySearch(langs, locale);
+		langcombo.setItems(langs);
 		if (langToSelectIndex >= 0) {
 			langcombo.select(langToSelectIndex);
 		}
@@ -162,6 +142,30 @@
 		
 	}
 	
+	public static String[] getAvailableLangs() {
+		
+		ArrayList<String> langList = new ArrayList<String>();
+		
+		String modelsDir = TreeTaggerPreferences.getInstance().getString(TreeTaggerPreferences.MODELS_PATH);
+		File files[] = new File(modelsDir).listFiles(IOUtils.HIDDENFILE_FILTER);
+		if (files != null && files.length > 0) {
+			for (File model : files) {
+				if (!model.getName().endsWith(".par")) continue; //$NON-NLS-1$
+				String lang = FileUtils.stripExtension(model);
+				langList.add(lang);
+			}
+		}
+		
+		if (langList.size() > 0) {
+			return langList.toArray(new String[langList.size()]);
+		} else {
+		
+			String[] tmp = { "bg", "cat", "zh", "cop", "cs", "dk", "nl", "en", "ee", "fi ", "fr", "gl", "gr", "de", "ne", "it", "kr", "lat", "mn", "pl", "pt", "ro", "ru", "sk", "sl", "es", "tz" }; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$ //$NON-NLS-6$ //$NON-NLS-7$ //$NON-NLS-8$ //$NON-NLS-9$ //$NON-NLS-10$ //$NON-NLS-11$ //$NON-NLS-12$ //$NON-NLS-13$ //$NON-NLS-14$ //$NON-NLS-15$ //$NON-NLS-16$ //$NON-NLS-17$ //$NON-NLS-18$ //$NON-NLS-19$ //$NON-NLS-20$ //$NON-NLS-21$ //$NON-NLS-22$ //$NON-NLS-23$ //$NON-NLS-24$ //$NON-NLS-25$ //$NON-NLS-26$ //$NON-NLS-27$
+			Arrays.sort(tmp);
+			return tmp;
+		}
+	}
+	
 	@Override
 	public void updateFields(Project project) {
 		if (this.section.isDisposed()) return;
Index: TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/editors/TXMEditor.java
===================================================================
--- TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/editors/TXMEditor.java	(revision 3627)
+++ TXM/trunk/org.txm.rcp/src/main/java/org/txm/rcp/editors/TXMEditor.java	(revision 3628)
@@ -124,6 +124,11 @@
 	 */
 	public final static String TOP_TOOLBAR_COMPUTE_BUTTON_ID = "compute"; //$NON-NLS-1$
 	
+	/**
+	 * ID defined in plugin.xml for the compute button contribution.
+	 */
+	public final static String TOP_TOOLBAR_REVERT_BUTTON_ID = "revert"; //$NON-NLS-1$
+	
 	public static final int MAX_NAME_LENGTH = 40;
 	
 	public static final int NMAXLINESTOTEST = 30;
@@ -175,6 +180,11 @@
 	protected ToolItem computeButton;
 	
 	/**
+	 * Revert tool item button.
+	 */
+	protected ToolItem revertButton;
+	
+	/**
 	 * To keep track of the parameters used for the last computing and updates only the widgets if a parameter has changed.
 	 */
 	// FIXME: SJ: useless?
@@ -270,7 +280,7 @@
 			
 			for (IConfigurationElement e : config) {
 				try {
-					Log.finer(" " + e.getName() + " from " + e.getContributor().getName()); //$NON-NLS-1$ //$NON-NLS-2$
+					Log.finest(" " + e.getName() + " from " + e.getContributor().getName()); //$NON-NLS-1$ //$NON-NLS-2$
 					final Object o = e.createExecutableExtension("class"); //$NON-NLS-1$
 					if (o instanceof TXMEditorExtension) {
 						ISafeRunnable runnable = new ISafeRunnable() {
@@ -443,6 +453,9 @@
 			// store the Compute button to access if later, especially from subclasses
 			this.computeButton = this.topToolBar.getItemByContributionId(TOP_TOOLBAR_COMPUTE_BUTTON_ID);
 			
+			// store the Compute button to access if later, especially from subclasses
+			this.revertButton = this.topToolBar.getItemByContributionId(TOP_TOOLBAR_REVERT_BUTTON_ID);
+			
 			// this.computeButton = new ToolItem(topToolBar, SWT.PUSH);//.topToolBar.getItemByContributionId(TOP_TOOLBAR_COMPUTE_BUTTON_ID);
 			// this.computeButton.setImage(IImageKeys.getImage(IImageKeys.START));
 			// this.computeButton.addSelectionListener(new ComputeSelectionListener(this, true));
@@ -1018,10 +1031,6 @@
 						Log.fine("TXMEditor.compute(): " + TXMEditor.this.getClass().getSimpleName() + ": computing failed."); //$NON-NLS-1$ //$NON-NLS-2$
 					}
 					
-					
-					
-					
-					
 					notifyExtensions("notifyEndOfCompute"); //$NON-NLS-1$
 					
 					// monitor.worked(50);
@@ -2071,6 +2080,15 @@
 	}
 	
 	/**
+	 * Gets the Compute Tool item button.
+	 * 
+	 * @return the computeButton
+	 */
+	protected ToolItem getRevertButton() {
+		return revertButton;
+	}
+	
+	/**
 	 * Removes the Compute Tool item button.
 	 */
 	protected void removeComputeButton() {
